#include <bits/stdc++.h>
using namespace std;

const long long MOD = 1000000007;

int N, J;
vector< vector<int> > strom;
vector<int> rodic;

void dfs(int kde, int odkial = -1) {
    rodic[kde] = odkial;
    for (int kam : strom[kde]) if (kam != odkial) dfs(kam, kde);
}

bool over(vector<int> bandasky) {
    while (true) {
        bool zmena = false;
        for (int n=0; n<N; ++n) if (n != J && bandasky[n] >= 2) {
            zmena = true;
            bandasky[rodic[n]] += bandasky[n]/2;
            bandasky[n] %= 2;
        }
        if (bandasky[J] > 0) return false;
        if (!zmena) return true;
    }
}

bool rozmiestni(int b) {
    vector<int> moznosti(N-1, 0);
    moznosti.resize(N+b-1, 1);
    do {
        vector<int> bandasky(N, 0);
        int kde = 0;
        for (int x : moznosti) if (x) ++bandasky[kde]; else ++kde;
        if (over(bandasky)) return true;
    } while (next_permutation(moznosti.begin(), moznosti.end()));
    return false;
}

int main() {
    cin >> N >> J;
    strom.resize(N);
    for (int n=0; n<N-1; ++n) {
        int x, y;
        cin >> x >> y;
        strom[x].push_back(y); 
        strom[y].push_back(x);
    }
    rodic.resize(N, -1);
    dfs(J);
    int odpoved = 0;
    while (rozmiestni(odpoved)) ++odpoved;
    cout << odpoved << endl;
}
