#include <bits/stdc++.h>
using namespace std;

const long long MOD = 1000000007;

int N, J;
vector< vector<int> > strom;
vector<int> rodic, hlbka, najhlbsi_syn;
long long odpoved;

void dfs(int kde, int odkial = -1) {
    rodic[kde] = odkial;
    for (int kam : strom[kde]) if (kam != odkial) {
        dfs(kam, kde);
        if (hlbka[kam] + 1 > hlbka[kde]) {
            hlbka[kde] = hlbka[kam] + 1;
            najhlbsi_syn[kde] = kam;
        }
    }
}

void vypln(int kde, long long kolko) {
    if (hlbka[kde] == 0) {
        // sme v liste
        odpoved = (odpoved + kolko) % MOD;
    } else {
        // tlacime dalej
        vypln( najhlbsi_syn[kde], (2*kolko+1)%MOD );
        for (int kam : strom[kde]) {
            if (kam == rodic[kde]) continue;
            if (kam == najhlbsi_syn[kde]) continue;
            vypln( kam, 1 );
        }
    }
}

int main() {
    cin >> N >> J;
    strom.resize(N);
    for (int n=0; n<N-1; ++n) {
        int x, y;
        cin >> x >> y;
        strom[x].push_back(y); 
        strom[y].push_back(x);
    }
    rodic.resize(N, -1);
    hlbka.resize(N, 0);
    najhlbsi_syn.resize(N, -1);
    dfs(J);
    odpoved = 0;
    vypln(J, 0);
    cout << ((1+odpoved)%MOD) << endl;
}
