#include <bits/stdc++.h>
using namespace std;

const long long MOD = 1000000007;

int N, J;
vector< vector<int> > strom;

long long pow2(int x) {
    long long odpoved = 1;
    while (x--) odpoved = (2*odpoved) % MOD;
    return odpoved;
}

int main() {
    cin >> N >> J;
    strom.resize(N);
    for (int n=0; n<N-1; ++n) {
        int x, y;
        cin >> x >> y;
        strom[x].push_back(y); 
        strom[y].push_back(x);
    }
    long long odpoved = 0;
    for (int sused : strom[J]) {
        int pred = J, hlbka = 1;
        while (true) {
            int dalej = -1;
            for (int x : strom[sused]) if (x != pred) dalej = x;
            if (dalej == -1) break;
            ++hlbka;
            pred = sused;
            sused = dalej;
        }
        odpoved += pow2(hlbka);
        odpoved -= 1;
        odpoved += MOD;
        odpoved %= MOD;
    }

    cout << ((1+odpoved)%MOD) << endl;
}
